(function(){
Template.__checkName("entireGameCard");
Template["entireGameCard"] = new Template("Template.entireGameCard", (function() {
  var view = this;
  return HTML.DIV({
    class: "loading-wrapper"
  }, "\n    ", HTML.DIV({
    class: function() {
      return [ "complete-game-card ten-spacing clear-fix ", Spacebars.mustache(view.lookup("status")), " animated fadeInRight" ];
    }
  }, "\n      ", HTML.Raw("<!-- {{> loadingGame}} animated-background -->"), "\n      ", Blaze._TemplateWith(function() {
    return {
      game: Spacebars.call(view.lookup("game")),
      border: Spacebars.call(true)
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("singleGameInfo"));
  }), "\n      ", Blaze._TemplateWith(function() {
    return {
      game: Spacebars.call(view.lookup("game"))
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("singleGameCard"));
  }), "\n      ", Blaze._TemplateWith(function() {
    return {
      game: Spacebars.call(view.lookup("game"))
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("singleGameCTA"));
  }), "\n    "), "\n  ");
}));

Template.__checkName("singleGameInfo");
Template["singleGameInfo"] = new Template("Template.singleGameInfo", (function() {
  var view = this;
  return [ Blaze.If(function() {
    return Spacebars.dataMustache(view.lookup("sport"), "MLB");
  }, function() {
    return [ "\n    ", Blaze.If(function() {
      return Spacebars.call(view.lookup("inProgress"));
    }, function() {
      return [ "\n      ", Blaze._TemplateWith(function() {
        return {
          game: Spacebars.call(view.lookup("game")),
          border: Spacebars.call(view.lookup("border"))
        };
      }, function() {
        return Spacebars.include(view.lookupTemplate("gameInProgressInfo"));
      }), "\n    " ];
    }), "\n  " ];
  }), "\n  ", Blaze.If(function() {
    return Spacebars.call(view.lookup("future"));
  }, function() {
    return [ "\n    ", Blaze._TemplateWith(function() {
      return {
        game: Spacebars.call(view.lookup("game")),
        border: Spacebars.call(view.lookup("border"))
      };
    }, function() {
      return Spacebars.include(view.lookupTemplate("futureGameInfo"));
    }), "\n  " ];
  }) ];
}));

Template.__checkName("singleGameCard");
Template["singleGameCard"] = new Template("Template.singleGameCard", (function() {
  var view = this;
  return HTML.DIV({
    class: "single-game-card"
  }, "\n    ", HTML.DIV({
    class: function() {
      return Spacebars.mustache(view.lookup("status"));
    },
    "data-action": "viewGame"
  }, "\n      ", Blaze.Each(function() {
    return {
      _sequence: Spacebars.call(view.lookup("teams")),
      _variable: "team"
    };
  }, function() {
    return [ "\n        ", Blaze._TemplateWith(function() {
      return {
        statsTeamId: Spacebars.call(Spacebars.dot(view.lookup("team"), "teamId")),
        runs: Spacebars.call(Spacebars.dot(view.lookup("team"), "runs")),
        hasBall: Spacebars.call(view.lookup("hasBall"))
      };
    }, function() {
      return Spacebars.include(view.lookupTemplate("teamBlock"));
    }), "\n      " ];
  }), "\n    "), "\n    ", Blaze.If(function() {
    return Spacebars.call(view.lookup("showRight"));
  }, function() {
    return [ "\n      ", Spacebars.include(view.lookupTemplate("rightSection")), "\n    " ];
  }), "\n  ");
}));

Template.__checkName("singleGameCTA");
Template["singleGameCTA"] = new Template("Template.singleGameCTA", (function() {
  var view = this;
  return [ Blaze.If(function() {
    return Spacebars.call(view.lookup("preGame"));
  }, function() {
    return [ "\n    ", HTML.DIV({
      "data-action": "pre-pickk",
      id: function() {
        return Spacebars.mustache(Spacebars.dot(view.lookup("game"), "id"));
      },
      class: "single-game-shared single-game-cta"
    }, "\n      Pre Pickks Open!\n    "), "\n  " ];
  }), "\n  ", Blaze.If(function() {
    return Spacebars.call(view.lookup("inProgress"));
  }, function() {
    return [ "\n    ", HTML.DIV({
      "data-action": "play",
      id: function() {
        return Spacebars.mustache(Spacebars.dot(view.lookup("game"), "id"));
      },
      class: "single-game-shared single-game-cta"
    }, "\n      Play Now!\n    "), "\n  " ];
  }) ];
}));

Template.__checkName("futureGameInfo");
Template["futureGameInfo"] = new Template("Template.futureGameInfo", (function() {
  var view = this;
  return HTML.DIV({
    class: function() {
      return [ "single-game-shared single-game-info future-game-info ", Spacebars.mustache(view.lookup("border")) ];
    }
  }, "\n    ", HTML.STRONG({
    class: "game-time"
  }, Blaze.View("lookup:displayDate", function() {
    return Spacebars.mustache(view.lookup("displayDate"), Spacebars.dot(view.lookup("game"), "iso"));
  })), "\n    ", HTML.SPAN({
    class: "game-tv"
  }, "\n      ", Blaze.Each(function() {
    return {
      _sequence: Spacebars.dataMustache(view.lookup("tv"), Spacebars.dot(view.lookup("game"), "tvStations")),
      _variable: "station"
    };
  }, function() {
    return [ "\n        (", Blaze.View("lookup:station.callLetters", function() {
      return Spacebars.mustache(Spacebars.dot(view.lookup("station"), "callLetters"));
    }), ")\n      " ];
  }), "\n    "), "\n  ");
}));

Template.__checkName("teamBlock");
Template["teamBlock"] = new Template("Template.teamBlock", (function() {
  var view = this;
  return HTML.DIV({
    class: "team-block"
  }, "\n    ", Spacebars.With(function() {
    return Spacebars.dataMustache(view.lookup("team"), view.lookup("statsTeamId"));
  }, function() {
    return [ "\n      ", HTML.DIV({
      class: "team-colors team-text",
      style: function() {
        return [ "background-color:", Spacebars.mustache(view.lookup("hex")) ];
      }
    }, "\n        ", Blaze.View("lookup:upper", function() {
      return Spacebars.mustache(view.lookup("upper"), view.lookup("computerName"));
    }), "\n      "), "\n    " ];
  }), "\n    ", HTML.DIV({
    class: "team-inner"
  }, "\n      ", HTML.SPAN({
    class: "team-name team-text"
  }, "\n        ", Spacebars.With(function() {
    return Spacebars.dataMustache(view.lookup("team"), view.lookup("statsTeamId"));
  }, function() {
    return [ "\n          ", Blaze.If(function() {
      return Spacebars.call(view.lookup("hasBall"));
    }, function() {
      return [ " ", HTML.CharRef({
        html: "&#9679;",
        str: "●"
      }), " " ];
    }), "\n          ", Blaze.View("lookup:nickname", function() {
      return Spacebars.mustache(view.lookup("nickname"));
    }), "\n        " ];
  }), "\n      "), "\n      ", HTML.SPAN({
    class: "team-score team-text"
  }, Blaze.View("lookup:runs", function() {
    return Spacebars.mustache(view.lookup("runs"));
  })), "\n    "), "\n  ");
}));

Template.__checkName("rightSection");
Template["rightSection"] = new Template("Template.rightSection", (function() {
  var view = this;
  return HTML.DIV({
    class: "additional-game-details"
  }, "\n    ", Blaze.If(function() {
    return Spacebars.call(view.lookup("completed"));
  }, function() {
    return [ "\n      ", HTML.DIV({
      class: "game-time-container center-text game-card-right-side-border"
    }, "\n        ", HTML.SPAN("View Game"), "\n      "), "\n    " ];
  }), "\n    ", Blaze.If(function() {
    return Spacebars.call(view.lookup("live"));
  }, function() {
    return [ "\n      ", HTML.DIV({
      class: "game-time-container center-text game-card-right-side-border"
    }, "\n        ", HTML.SPAN({
      class: "period"
    }, "\n          ", Blaze.View("lookup:periodGrammer", function() {
      return Spacebars.mustache(view.lookup("periodGrammer"), Spacebars.dot(view.lookup("."), "game", "period"));
    }), "\n        "), "\n        ", HTML.SPAN({
      class: "time-remaining"
    }, Blaze.View("lookup:time", function() {
      return Spacebars.mustache(view.lookup("time"));
    })), "\n        ", HTML.SPAN({
      class: "tv-station"
    }, "\n          ", Blaze.View("lookup:tvStation", function() {
      return Spacebars.mustache(view.lookup("tvStation"), Spacebars.dot(view.lookup("."), "game", "tvStations"));
    }), "\n        "), "\n      "), "\n    " ];
  }), "\n    ", Blaze.If(function() {
    return Spacebars.call(view.lookup("scheduled"));
  }, function() {
    return [ "\n      ", Blaze.If(function() {
      return Spacebars.call(view.lookup("registered"));
    }, function() {
      return [ "\n        ", HTML.DIV({
        "data-action": "unregister",
        class: "game-unregister center"
      }, "\n          ", HTML.I({
        class: "fa fa-bell-slash"
      }), "\n        "), "\n      " ];
    }, function() {
      return [ "\n        ", HTML.DIV({
        "data-action": "register",
        class: "game-register cta-button center"
      }, "\n          ", HTML.I({
        class: "fa fa-bell"
      }), "\n        "), "\n      " ];
    }), "\n    " ];
  }), "\n    ", Blaze.If(function() {
    return Spacebars.call(view.lookup("delayed"));
  }, function() {
    return [ "\n      ", HTML.DIV({
      class: "game-time-container center-text game-card-right-side-border"
    }, "\n        View Game\n      "), "\n    " ];
  }), "\n  ");
}));

Template.__checkName("loadingGame");
Template["loadingGame"] = new Template("Template.loadingGame", (function() {
  var view = this;
  return HTML.Raw('<div class="load-game">\n    <div class="load-game-top">\n      <div class="blue-block top-rounded"></div>\n      <div class="load-game-top-text">\n        <div class="blue-block top-left"></div>\n        <div class="top-left-text"></div>\n        <div class="blue-block top-middle"></div>\n        <div class="top-right-text"></div>\n        <div class="blue-block top-right"></div>\n      </div>\n      <div class="blue-block full-width"></div>\n    </div>\n    <div class="load-game-middle-container">\n      <div class="load-game-team-row"> <!--Team 1 -->\n        <div class="load-game-middle-shortcode">\n          <div class="whitespace-block shortcode-text"></div>\n        </div>\n        <div class="load-game-team-right">\n          <div class="whitespace-block middle-spacer"></div>\n          <div class="load-game-middle-text-row">\n            <div class="whitespace-block middle-left"></div>\n            <div class="whitespace-block middle-middle"></div>\n            <div class="whitespace-block middle-right"></div>\n          </div>\n          <div class="whitespace-block middle-spacer"></div>\n        </div>\n      </div>\n      <div class="load-game-team-row"> <!--Team 2 -->\n        <div class="load-game-middle-shortcode">\n          <div class="whitespace-block shortcode-text"></div>\n        </div>\n        <div class="load-game-team-right">\n          <div class="whitespace-block middle-spacer"></div>\n          <div class="load-game-middle-text-row">\n            <div class="whitespace-block middle-left"></div>\n            <div class="whitespace-block middle-middle"></div>\n            <div class="whitespace-block middle-right"></div>\n          </div>\n          <div class="whitespace-block middle-spacer rounded-bottom-right-edge"></div>\n        </div>\n      </div>\n    </div>\n    <div class="load-game-bottom">\n      <div class="yellow-block full-width"></div>\n      <div class="load-game-bottom-text">\n        <div class="yellow-block bottom-left"></div>\n        <div class="bottom-middle"></div>\n        <div class="yellow-block bottom-right"></div>\n      </div>\n      <div class="yellow-block bottom-rounded"></div>\n    </div>\n  </div>');
}));

}).call(this);
