(function(){
Template.__checkName("heroImage");
Template["heroImage"] = new Template("Template.heroImage", (function() {
  var view = this;
  return HTML.DIV({
    class: "single-slide",
    style: function() {
      return [ "background-image: url(", Spacebars.mustache(Spacebars.dot(view.lookup("item"), "image")), ")" ];
    }
  }, "\n    ", HTML.DIV({
    class: "slider-text"
  }, "\n      ", Blaze.View("lookup:item.text", function() {
    return Spacebars.mustache(Spacebars.dot(view.lookup("item"), "text"));
  }), "\n    "), "\n  ");
}));

Template.__checkName("heroSection");
Template["heroSection"] = new Template("Template.heroSection", (function() {
  var view = this;
  return [ HTML.DIV({
    style: "min-height: 180px;"
  }, "\n    ", HTML.Raw("<!-- {{#if Template.subscriptionsReady}} -->"), "\n      ", HTML.DIV({
    id: "hero-section",
    class: "animated fadeInDown"
  }, "\n        ", Spacebars.include(view.lookupTemplate("heroInBetween")), "\n      "), "\n    ", HTML.Raw("<!-- {{/if}} -->"), "\n  "), HTML.Raw('\n  <div class="line-divider"></div>') ];
}));

Template.__checkName("heroInBetween");
Template["heroInBetween"] = new Template("Template.heroInBetween", (function() {
  var view = this;
  return Blaze.Each(function() {
    return {
      _sequence: Spacebars.call(view.lookup("heros")),
      _variable: "hero"
    };
  }, function() {
    return [ "\n    ", HTML.DIV({
      class: "single-slide"
    }, "\n      ", Blaze._TemplateWith(function() {
      return {
        hero: Spacebars.call(view.lookup("hero"))
      };
    }, function() {
      return Spacebars.include(view.lookupTemplate("singleHero"));
    }), "\n    "), "\n  " ];
  });
}));

Template.__checkName("singleHero");
Template["singleHero"] = new Template("Template.singleHero", (function() {
  var view = this;
  return HTML.A({
    href: function() {
      return Spacebars.mustache(Spacebars.dot(view.lookup("hero"), "url"));
    }
  }, "\n  ", HTML.DIV({
    class: "card-container hero-card"
  }, "\n    ", HTML.DIV({
    class: "hero-image",
    style: function() {
      return [ "background-image: url(", Spacebars.mustache(Spacebars.dot(view.lookup("hero"), "image")), ")" ];
    }
  }, "\n      ", HTML.SPAN({
    class: "title"
  }, Blaze.View("lookup:hero.title", function() {
    return Spacebars.mustache(Spacebars.dot(view.lookup("hero"), "title"));
  })), "\n    "), "\n    ", HTML.DIV({
    class: "hero-bottom"
  }, "\n      ", HTML.DIV({
    class: "description"
  }, "\n        ", Blaze.View("lookup:hero.description", function() {
    return Spacebars.mustache(Spacebars.dot(view.lookup("hero"), "description"));
  }), "\n      "), "\n      ", HTML.SPAN({
    class: "arrow"
  }, Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("ios-arrow-right")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("ionIcon"));
  })), "\n    "), "\n  "), "\n  ");
}));

}).call(this);
