(function(){
Template.__checkName("standardNav");
Template["standardNav"] = new Template("Template.standardNav", (function() {
  var view = this;
  return Blaze._TemplateWith(function() {
    return "headerButtonLeft";
  }, function() {
    return Spacebars.include(view.lookupTemplate("contentFor"), function() {
      return [ "\n    ", HTML.BUTTON({
        class: "button button-clear nav-icon pull-left",
        "data-ion-menu-toggle": "left"
      }, "\n      ", Blaze.If(function() {
        return Spacebars.call(view.lookup("isAndroid"));
      }, function() {
        return [ "\n        ", Blaze._TemplateWith(function() {
          return {
            icon: Spacebars.call("android-more-vertical")
          };
        }, function() {
          return Spacebars.include(view.lookupTemplate("ionIcon"));
        }), "\n      " ];
      }, function() {
        return [ "\n        ", Blaze._TemplateWith(function() {
          return {
            icon: Spacebars.call("navicon")
          };
        }, function() {
          return Spacebars.include(view.lookupTemplate("ionIcon"));
        }), "\n      " ];
      }), "\n    "), "\n  " ];
    });
  });
}));

Template.__checkName("deepBackButton");
Template["deepBackButton"] = new Template("Template.deepBackButton", (function() {
  var view = this;
  return HTML.BUTTON({
    class: function() {
      return Spacebars.mustache(view.lookup("classes"));
    },
    "data-action": "deepBack"
  }, "\n    ", Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call(view.lookup("icon"))
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("ionIcon"));
  }), " ", Blaze.Unless(function() {
    return Spacebars.call(view.lookup("isAndroid"));
  }, function() {
    return [ "\n    ", HTML.SPAN({
      class: "back-text"
    }, "\n      ", Blaze.View("lookup:text", function() {
      return Spacebars.mustache(view.lookup("text"));
    }), "\n    "), "\n    " ];
  }), "\n  ");
}));

Template.__checkName("spinLoader");
Template["spinLoader"] = new Template("Template.spinLoader", (function() {
  var view = this;
  return HTML.DIV({
    class: "loader-holder"
  }, "\n    ", HTML.SVG({
    class: "spin-loader",
    version: "1.1",
    id: "loader-1",
    xmlns: "http://www.w3.org/2000/svg",
    "xmlns:xlink": "http://www.w3.org/1999/xlink",
    x: "0px",
    y: "0px",
    width: "40px",
    height: "40px",
    viewBox: "0 0 50 50",
    style: "enable-background:new 0 0 50 50; margin-top:50%",
    "xml:space": "preserve"
  }, "\n    ", HTML.PATH({
    fill: "#000",
    d: "M43.935,25.145c0-10.318-8.364-18.683-18.683-18.683c-10.318,0-18.683,8.365-18.683,18.683h4.068c0-8.071,6.543-14.615,14.615-14.615c8.072,0,14.615,6.543,14.615,14.615H43.935z"
  }, "\n      ", HTML.ANIMATETRANSFORM({
    attributeType: "xml",
    attributeName: "transform",
    type: "rotate",
    from: "0 25 25",
    to: "360 25 25",
    dur: "0.6s",
    repeatCount: "indefinite"
  }), "\n      "), "\n    "), "\n    ");
}));

Template.__checkName("loader");
Template["loader"] = new Template("Template.loader", (function() {
  var view = this;
  return [ Spacebars.include(view.lookupTemplate("pickkLoader")), "\n  ", Blaze.If(function() {
    return Spacebars.call(view.lookup("takingAwhile"));
  }, function() {
    return [ "\n  ", HTML.DIV({
      class: "col-md-100 center animated fast fadeInUp"
    }, "\n    ", HTML.DIV({
      id: "whoops",
      class: "center-text container"
    }, "\n      ", HTML.H4("Whoops..."), "\n      ", HTML.P("Shouldnt Take This Long."), "\n      ", HTML.P("Slow Load Reported"), "\n      ", HTML.BUTTON({
      "data-action": "back",
      class: "button button-stable"
    }, "\n        Previous\n      "), "\n      ", HTML.BUTTON({
      "data-action": "reload",
      class: "button button-balanced"
    }, "\n        Home\n      "), "\n    "), "\n  "), "\n  " ];
  }) ];
}));

Template.__checkName("pickkLoader");
Template["pickkLoader"] = new Template("Template.pickkLoader", (function() {
  var view = this;
  return HTML.DIV({
    class: "col-md-100 center loader-holder",
    style: "padding-top: 100px;"
  }, "\n", HTML.SVG({
    width: "75",
    height: "75",
    class: "center",
    style: "enable-background:new 0 0 50 50; margin-top:100px;",
    viewBox: "-5 -5 95 95",
    xmlns: "http://www.w3.org/2000/svg"
  }, "\n", HTML.TITLE("Pickk Mark"), "\n", HTML.G({
    class: "pickk-mark"
  }, "\n  ", HTML.PATH({
    d: "M83.7935 8.5019l-19.354 11.326c-1.084.635-2.468.399-3.282-.559l-15.555-18.3c-.549-.645-1.321-.968-2.094-.968-.772 0-1.545.323-2.094.968l-15.555 18.3c-.814.958-2.198 1.194-3.282.559L3.2235 8.5019c-1.452-.85-3.228.412-2.903 2.064l11.49 57.255.006-.012c2.19 10.189 15.448 18.087 31.692 18.468 16.245-.381 29.502-8.279 31.692-18.468l.007.012 11.49-57.255c.325-1.652-1.451-2.914-2.904-2.064",
    class: "crown",
    fill: "transparent"
  }, "\n  "), "\n", HTML.PATH({
    d: "M68.0669 59.2817c-5.776 7.164-14.622 11.751-24.542 11.751-9.934 0-18.789-4.6-24.564-11.78-.005.004-.009.008-.013.013-2.775 3.446-4.844 7.483-5.977 11.898 4.07 8.519 16.121 14.773 30.531 15.112 2.092-.049 4.134-.225 6.112-.513 11.631-1.692 20.94-7.318 24.419-14.599-1.132-4.408-3.196-8.44-5.966-11.882",
    class: "bottom-band",
    fill: "transparent"
  }), "\n", HTML.PATH({
    d: "M18.9595 59.2534c5.777 7.182 14.632 11.781 24.566 11.781 9.92 0 18.764-4.587 24.542-11.751-5.777-7.18-14.631-11.781-24.566-11.781-9.919 0-18.764 4.587-24.542 11.751z",
    class: "eye",
    fill: "transparent"
  }), "\n", HTML.G({
    class: "coin"
  }, "\n  ", HTML.PATH({
    d: "M52.2017 59.268c0 4.821-3.909 8.73-8.731 8.73s-8.731-3.909-8.731-8.73c0-4.822 3.909-8.731 8.731-8.731s8.731 3.909 8.731 8.731",
    class: "outer-coin",
    fill: "transparent"
  }), "\n  ", HTML.PATH({
    d: "M49.6548 59.268c0 3.416-2.769 6.185-6.185 6.185-3.415 0-6.185-2.769-6.185-6.185 0-3.416 2.77-6.186 6.185-6.186 3.416 0 6.185 2.77 6.185 6.186",
    class: "inner-coin",
    fill: "transparent"
  }), "\n"), "\n"), "\n"), "\n");
}));

}).call(this);
