(function(){
Template.__checkName("singleLeague");
Template["singleLeague"] = new Template("Template.singleLeague", (function() {
  var view = this;
  return [ HTML.Raw("<!-- Standard Nav instead of the custom nav design -->\n  "), Blaze._TemplateWith(function() {
    return "headerButtonLeft";
  }, function() {
    return Spacebars.include(view.lookupTemplate("contentFor"), function() {
      return [ "\n    ", Blaze._TemplateWith(function() {
        return {
          where: Spacebars.call("leagues")
        };
      }, function() {
        return Spacebars.include(view.lookupTemplate("deepBackButton"));
      }), "\n  " ];
    });
  }), "\n\n  ", Spacebars.include(view.lookupTemplate("chatIcon")), "\n\n  ", Blaze._TemplateWith(function() {
    return "headerTitle";
  }, function() {
    return Spacebars.include(view.lookupTemplate("contentFor"), function() {
      return [ "\n    ", HTML.H1({
        class: "title white-text-header"
      }, "\n      ", Blaze.View("lookup:leagueName", function() {
        return Spacebars.mustache(view.lookup("leagueName"));
      }), "\n    "), "\n  " ];
    });
  }), "\n\n  ", Spacebars.include(view.lookupTemplate("ionView"), function() {
    return [ "\n    ", Spacebars.include(view.lookupTemplate("ionContent"), function() {
      return [ "\n      ", HTML.DIV({
        class: "container hundred-bottom"
      }, "\n        ", Spacebars.With(function() {
        return Spacebars.call(view.lookup("league"));
      }, function() {
        return [ "\n          ", Spacebars.include(view.lookupTemplate("leagueCard")), "\n        " ];
      }), "\n\n        ", Blaze.If(function() {
        return Spacebars.call(view.lookup("visible"));
      }, function() {
        return [ "\n          ", Blaze.If(function() {
          return Spacebars.call(view.lookup("member"));
        }, function() {
          return [ "\n            ", HTML.DIV({
            class: "line-divider"
          }), "\n            ", HTML.DIV({
            id: "button-section"
          }, "\n              ", Spacebars.include(view.lookupTemplate("leagueLinks")), "\n              ", Spacebars.include(view.lookupTemplate("commissionerLinks")), "\n            "), "\n            ", HTML.DIV({
            class: "line-divider"
          }), "\n            ", Spacebars.include(view.lookupTemplate("leagueMatchups")), "\n          " ];
        }, function() {
          return [ "\n            ", Spacebars.include(view.lookupTemplate("memberCheck")), "\n            ", HTML.DIV({
            class: "line-divider"
          }), "\n            ", Spacebars.include(view.lookupTemplate("visitorLinks")), "\n          " ];
        }), "\n        " ];
      }, function() {
        return [ "\n          ", HTML.DIV({
          class: "no-notifications"
        }, "\n            This league is private and can only be seen by members\n          "), "\n        " ];
      }), "\n      "), "\n   " ];
    }), "\n  " ];
  }) ];
}));

Template.__checkName("chatIcon");
Template["chatIcon"] = new Template("Template.chatIcon", (function() {
  var view = this;
  return Blaze.If(function() {
    return Spacebars.call(view.lookup("member"));
  }, function() {
    return [ "\n    ", Blaze._TemplateWith(function() {
      return "headerButtonRight";
    }, function() {
      return Spacebars.include(view.lookupTemplate("contentFor"), function() {
        return [ "\n      ", HTML.BUTTON({
          style: "font-size: 13px;",
          class: "button button-clear",
          "data-ion-menu-toggle": "right"
        }, "\n        ", Blaze._TemplateWith(function() {
          return {
            icon: Spacebars.call("ios-chatboxes")
          };
        }, function() {
          return Spacebars.include(view.lookupTemplate("ionIcon"));
        }), "\n      "), "\n    " ];
      });
    }), "\n  " ];
  });
}));

Template.__checkName("leagueMatchups");
Template["leagueMatchups"] = new Template("Template.leagueMatchups", (function() {
  var view = this;
  return Blaze.If(function() {
    return Spacebars.call(view.lookup("leagueMatchups"));
  }, function() {
    return [ "\n    ", Blaze._TemplateWith(function() {
      return {
        leagueId: Spacebars.call(Spacebars.dot(view.lookup("."), "league", "_id")),
        type: Spacebars.call("league")
      };
    }, function() {
      return Spacebars.include(view.lookupTemplate("matchupCardList"));
    }), "\n  " ];
  }, function() {
    return [ "\n    ", HTML.DIV({
      class: "no-notifications container"
    }, "\n      No Matchups Scheduled\n      ", Blaze.If(function() {
      return Spacebars.call(view.lookup("commissionerAdmin"));
    }, function() {
      return [ "\n        ", HTML.BUTTON({
        class: "ten-spacing button button-stable col col-100",
        "data-action": "createMatchup"
      }, "Create Matchup"), "\n      " ];
    }), "\n    "), "\n  " ];
  });
}));

Template.__checkName("leagueLinks");
Template["leagueLinks"] = new Template("Template.leagueLinks", (function() {
  var view = this;
  return [ HTML.DIV({
    class: "button-card half",
    "data-action": "viewMembers"
  }, "\n    ", Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("player"),
      size: Spacebars.call("small")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("pickkIcon"));
  }), "\n    ", HTML.Raw('<span class="text">Players</span>'), "\n    ", HTML.SPAN({
    class: "arrow"
  }, Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("ios-arrow-right")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("ionIcon"));
  })), "\n  "), "\n  ", HTML.DIV({
    class: function() {
      return [ "button-card half ", Spacebars.mustache(view.lookup("ifPlayer")) ];
    },
    "data-action": "invite"
  }, "\n    ", Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("invite"),
      size: Spacebars.call("small")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("pickkIcon"));
  }), "\n    ", HTML.Raw('<span class="text">Invite</span>'), "\n    ", HTML.SPAN({
    class: "arrow"
  }, Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("ios-arrow-right")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("ionIcon"));
  })), "\n  "), "\n  ", HTML.DIV({
    class: "button-card half",
    "data-action": "viewLeaderboard"
  }, "\n    ", Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("leaderboard"),
      size: Spacebars.call("small")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("pickkIcon"));
  }), "\n    ", HTML.Raw('<span class="text">Leaderboard</span>'), "\n    ", HTML.SPAN({
    class: "arrow"
  }, Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("ios-arrow-right")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("ionIcon"));
  })), "\n  "), "\n  ", Blaze.If(function() {
    return Spacebars.call(view.lookup("notCommissioner"));
  }, function() {
    return [ "\n    ", HTML.DIV({
      class: "button-card half",
      "data-action": "settings"
    }, "\n      ", Blaze._TemplateWith(function() {
      return {
        icon: Spacebars.call("settings"),
        size: Spacebars.call("small")
      };
    }, function() {
      return Spacebars.include(view.lookupTemplate("pickkIcon"));
    }), "\n      ", HTML.SPAN({
      class: "text"
    }, "Settings"), "\n      ", HTML.SPAN({
      class: "arrow"
    }, Blaze._TemplateWith(function() {
      return {
        icon: Spacebars.call("ios-arrow-right")
      };
    }, function() {
      return Spacebars.include(view.lookupTemplate("ionIcon"));
    })), "\n    "), "\n  " ];
  }) ];
}));

Template.__checkName("commissionerLinks");
Template["commissionerLinks"] = new Template("Template.commissionerLinks", (function() {
  var view = this;
  return Blaze.If(function() {
    return Spacebars.call(view.lookup("commissioner"));
  }, function() {
    return [ "\n    ", HTML.DIV({
      class: "button-card half",
      "data-action": "settings"
    }, "\n      ", Blaze._TemplateWith(function() {
      return {
        icon: Spacebars.call("settings"),
        size: Spacebars.call("small")
      };
    }, function() {
      return Spacebars.include(view.lookupTemplate("pickkIcon"));
    }), "\n      ", HTML.SPAN({
      class: "text"
    }, "Settings"), "\n      ", HTML.SPAN({
      class: "arrow"
    }, Blaze._TemplateWith(function() {
      return {
        icon: Spacebars.call("ios-arrow-right")
      };
    }, function() {
      return Spacebars.include(view.lookupTemplate("ionIcon"));
    })), "\n    "), "\n    ", Blaze.If(function() {
      return Spacebars.call(view.lookup("requests"));
    }, function() {
      return [ "\n      ", HTML.DIV({
        class: "button-card half",
        "data-action": "_leagueRequests"
      }, "\n        ", Blaze._TemplateWith(function() {
        return {
          icon: Spacebars.call("settings"),
          size: Spacebars.call("players")
        };
      }, function() {
        return Spacebars.include(view.lookupTemplate("pickkIcon"));
      }), "\n        ", HTML.SPAN({
        class: "text"
      }, "Requests"), "\n        ", HTML.SPAN({
        class: "arrow"
      }, Blaze._TemplateWith(function() {
        return {
          icon: Spacebars.call("ios-arrow-right")
        };
      }, function() {
        return Spacebars.include(view.lookupTemplate("ionIcon"));
      })), "\n      "), "\n    " ];
    }), "\n  " ];
  });
}));

Template.__checkName("visitorLinks");
Template["visitorLinks"] = new Template("Template.visitorLinks", (function() {
  var view = this;
  return HTML.DIV({
    id: "button-section"
  }, "\n    ", HTML.DIV({
    class: "button-card half",
    "data-action": "viewMembers"
  }, "\n      ", Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("player"),
      size: Spacebars.call("small")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("pickkIcon"));
  }), "\n      ", HTML.Raw('<span class="text">Players</span>'), "\n      ", HTML.SPAN({
    class: "arrow"
  }, Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("ios-arrow-right")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("ionIcon"));
  })), "\n    "), "\n    ", HTML.DIV({
    class: "button-card half",
    "data-action": "viewLeaderboard"
  }, "\n      ", Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("leaderboard"),
      size: Spacebars.call("small")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("pickkIcon"));
  }), "\n      ", HTML.Raw('<span class="text">Leaderboard</span>'), "\n      ", HTML.SPAN({
    class: "arrow"
  }, Blaze._TemplateWith(function() {
    return {
      icon: Spacebars.call("ios-arrow-right")
    };
  }, function() {
    return Spacebars.include(view.lookupTemplate("ionIcon"));
  })), "\n    "), "\n  ");
}));

}).call(this);
