//////////////////////////////////////////////////////////////////////////
//                                                                      //
// This is a generated file. You can view the original                  //
// source in your browser if your browser supports source maps.         //
// Source maps are supported by all recent versions of Chrome, Safari,  //
// and Firefox, and by Internet Explorer 11.                            //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var _ = Package.underscore._;
var check = Package.check.check;
var Match = Package.check.Match;
var Mousetrap = Package['mousetrap:mousetrap'].Mousetrap;

/* Package-scope variables */
var Hotkeys;

(function(){

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                  //
// packages/flowkey_hotkeys/hotkeys.js                                                                              //
//                                                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                    //
// Object to save the replaced hotkeys                                                                              // 1
var comboMap = {};                                                                                                  // 2
                                                                                                                    // 3
Hotkeys = function(options) {                                                                                       // 4
    this.hotkeys = [];                                                                                              // 5
                                                                                                                    // 6
    if (!options || options.autoLoad === undefined) {                                                               // 7
        this.autoLoad = true;                                                                                       // 8
    } else {                                                                                                        // 9
        this.autoLoad = options.autoLoad;                                                                           // 10
    }                                                                                                               // 11
}                                                                                                                   // 12
                                                                                                                    // 13
_.extend(Hotkeys.prototype, {                                                                                       // 14
    add: function(obj) {                                                                                            // 15
        var combo = obj.combo;                                                                                      // 16
        var description = obj.description;                                                                          // 17
        var evenType = obj.evenType;                                                                                // 18
        var callback = obj.callback;                                                                                // 19
                                                                                                                    // 20
        // add all hotkeys to local collection                                                                      // 21
        this.hotkeys.push(obj);                                                                                     // 22
                                                                                                                    // 23
        // Small Error check                                                                                        // 24
        if(!_.isArray(combo)){                                                                                      // 25
            check(combo, String);                                                                                   // 26
        }                                                                                                           // 27
                                                                                                                    // 28
        if(!_.isString(evenType)){                                                                                  // 29
            evenType = '';                                                                                          // 30
        }                                                                                                           // 31
                                                                                                                    // 32
        if (!_.isFunction(callback)) {                                                                              // 33
            throw new Meteor.Error(001, 'Error 001: Callback is not a Function');                                   // 34
        }                                                                                                           // 35
                                                                                                                    // 36
        var comboMapEntry = comboMap[combo];                                                                        // 37
        if (!_.isArray(comboMapEntry)) {                                                                            // 38
             comboMap[combo] = []                                                                                   // 39
        }                                                                                                           // 40
        if (this.autoLoad === true) {                                                                               // 41
            comboMap[combo].push(callback);                                                                         // 42
            Mousetrap.bind(combo, callback, evenType);                                                              // 43
        }                                                                                                           // 44
    },                                                                                                              // 45
    load: function() {                                                                                              // 46
        var allHotkeys = this.hotkeys;                                                                              // 47
        _.each(allHotkeys, function(hotkey) {                                                                       // 48
            comboMap[hotkey.combo].push(hotkey.callback);                                                           // 49
            Mousetrap.bind(hotkey.combo, hotkey.callback, hotkey.evenType);                                         // 50
        })                                                                                                          // 51
                                                                                                                    // 52
    },                                                                                                              // 53
    unload: function() {                                                                                            // 54
        var allHotkeys = this.hotkeys;                                                                              // 55
        _.each(allHotkeys, function(hotkey) {                                                                       // 56
            var comboMapEntry = comboMap[hotkey.combo];                                                             // 57
                                                                                                                    // 58
            _.each(comboMapEntry, function(func, index){                                                            // 59
            	if(func == hotkey.callback){                                                                           // 60
					comboMap[hotkey.combo].splice(index,1);                                                                        // 61
            	}                                                                                                      // 62
            });                                                                                                     // 63
                                                                                                                    // 64
            // bind it back to the original one                                                                     // 65
            if(comboMapEntry.length > 0){                                                                           // 66
                Mousetrap.bind(hotkey.combo, comboMap[hotkey.combo][comboMapEntry.length -1 ], hotkey.evenType);   
            }else{                                                                                                  // 68
                Mousetrap.unbind(hotkey.combo);                                                                     // 69
            }                                                                                                       // 70
                                                                                                                    // 71
        })                                                                                                          // 72
                                                                                                                    // 73
    }                                                                                                               // 74
})                                                                                                                  // 75
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['flowkey:hotkeys'] = {}, {
  Hotkeys: Hotkeys
});

})();
