//////////////////////////////////////////////////////////////////////////
//                                                                      //
// This is a generated file. You can view the original                  //
// source in your browser if your browser supports source maps.         //
// Source maps are supported by all recent versions of Chrome, Safari,  //
// and Firefox, and by Internet Explorer 11.                            //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var Template = Package['templating-runtime'].Template;
var $ = Package.jquery.$;
var jQuery = Package.jquery.jQuery;
var Blaze = Package.blaze.Blaze;
var UI = Package.blaze.UI;
var Handlebars = Package.blaze.Handlebars;
var Spacebars = Package.spacebars.Spacebars;
var HTML = Package.htmljs.HTML;

/* Package-scope variables */
var UiHooks;

(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                             //
// packages/gwendall_ui-hooks/packages/gwendall_ui-hooks.js                                                    //
//                                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                               //
(function () {                                                                                                 // 1
                                                                                                               // 2
//////////////////////////////////////////////////////////////////////////////////////////////////////////     // 3
//                                                                                                      //     // 4
// packages/gwendall:ui-hooks/lib.js                                                                    //     // 5
//                                                                                                      //     // 6
//////////////////////////////////////////////////////////////////////////////////////////////////////////     // 7
                                                                                                        //     // 8
UiHooks = {};                                                                                           // 1   // 9
                                                                                                        // 2   // 10
UiHooks.defaults = {                                                                                    // 3   // 11
  insert: function(node, next, container) {                                                             // 4   // 12
    if (next) {                                                                                         // 5   // 13
      $(node).insertBefore(next);                                                                       // 6   // 14
    } else {                                                                                            // 7   // 15
      $(container).append(node);                                                                        // 8   // 16
    }                                                                                                   // 9   // 17
  },                                                                                                    // 10  // 18
  move: function(node, next, container) {                                                               // 11  // 19
    UiHooks.defaults.remove(node);                                                                      // 12  // 20
    UiHooks.defaults.insert(node, next, container);                                                     // 13  // 21
  },                                                                                                    // 14  // 22
  remove: function(node) {                                                                              // 15  // 23
    $(node).remove();                                                                                   // 16  // 24
  }                                                                                                     // 17  // 25
};                                                                                                      // 18  // 26
                                                                                                        // 19  // 27
var allFalse = function(array) {                                                                        // 20  // 28
  var hasOnlyFalse = true;                                                                              // 21  // 29
  array.forEach(function(item) {                                                                        // 22  // 30
    if (item) return hasOnlyFalse = false;                                                              // 23  // 31
  });                                                                                                   // 24  // 32
  return hasOnlyFalse;                                                                                  // 25  // 33
};                                                                                                      // 26  // 34
                                                                                                        // 27  // 35
var makeHook = function(hooks, defaultCallback) {                                                       // 28  // 36
  return function() {                                                                                   // 29  // 37
    var args = arguments;                                                                               // 30  // 38
    var hooksResults = [];                                                                              // 31  // 39
    var self = this;                                                                                    // 32  // 40
    hooks.forEach(function(hook) {                                                                      // 33  // 41
      hooksResults.push(hook.apply(self, args));                                                        // 34  // 42
    });                                                                                                 // 35  // 43
    if (!defaultCallback) return;                                                                       // 36  // 44
    if (allFalse(hooksResults)) {                                                                       // 37  // 45
      return defaultCallback.apply(self, args);                                                         // 38  // 46
    }                                                                                                   // 39  // 47
  }                                                                                                     // 40  // 48
};                                                                                                      // 41  // 49
                                                                                                        // 42  // 50
Template.prototype.uihooks = function(hooksAll) {                                                       // 43  // 51
  var tpl = this;                                                                                       // 44  // 52
  tpl.onRendered(function() {                                                                           // 45  // 53
    if (!tpl.viewName) return;                                                                          // 46  // 54
    tpl = this;                                                                                         // 47  // 55
    var tplContainer = $(tpl.firstNode.parentNode);                                                     // 48  // 56
    for (var selector in hooksAll) {                                                                    // 49  // 57
      var hooks = hooksAll[selector];                                                                   // 50  // 58
      var declaredContainer = hooks.container && $(hooks.container);                                    // 51  // 59
      var itemsContainer = tpl.$(selector).length && tpl.$(selector).first().parent();                  // 52  // 60
      var container = declaredContainer || itemsContainer || tplContainer;                              // 53  // 61
      $(container).each(function() {                                                                    // 54  // 62
                                                                                                        // 55  // 63
        if (!this._alluihooks) {                                                                        // 56  // 64
          this._alluihooks = {                                                                          // 57  // 65
            insert: [],                                                                                 // 58  // 66
            move: [],                                                                                   // 59  // 67
            remove: []                                                                                  // 60  // 68
          };                                                                                            // 61  // 69
          if (this._uihooks) {                                                                          // 62  // 70
            if (this._uihooks.insertElement) this._alluihooks.insert.push(this._uihooks.insertElement); // 63  // 71
            if (this._uihooks.moveElement) this._alluihooks.move.push(this._uihooks.moveElement);       // 64  // 72
            if (this._uihooks.removeElement) this._alluihooks.remove.push(this._uihooks.removeElement); // 65  // 73
          }                                                                                             // 66  // 74
        }                                                                                               // 67  // 75
                                                                                                        // 68  // 76
        this._alluihooks.insert.push(function(node, next) {                                             // 69  // 77
          if (!$(node).is(selector)) return false;                                                      // 70  // 78
          hooks.insert && hooks.insert.apply(this, [node, next, tpl]);                                  // 71  // 79
          return true;                                                                                  // 72  // 80
        });                                                                                             // 73  // 81
                                                                                                        // 74  // 82
        this._alluihooks.move.push(function(node, next) {                                               // 75  // 83
          if (!$(node).is(selector)) return false;                                                      // 76  // 84
          hooks.move && hooks.move.apply(this, [node, next, tpl]);                                      // 77  // 85
          return true;                                                                                  // 78  // 86
        });                                                                                             // 79  // 87
                                                                                                        // 80  // 88
        this._alluihooks.remove.push(function(node) {                                                   // 81  // 89
          if (!$(node).is(selector)) return false;                                                      // 82  // 90
          hooks.remove && hooks.remove.apply(this, [node, tpl]);                                        // 83  // 91
          return true;                                                                                  // 84  // 92
        });                                                                                             // 85  // 93
                                                                                                        // 86  // 94
        var self = this;                                                                                // 87  // 95
        this._uihooks = {                                                                               // 88  // 96
          insertElement: makeHook(this._alluihooks.insert, function(node, next) {                       // 89  // 97
            return UiHooks.defaults.insert(node, next, self);                                           // 90  // 98
          }),                                                                                           // 91  // 99
          moveElement: makeHook(this._alluihooks.move, function(node, next) {                           // 92  // 100
            return UiHooks.defaults.move(node, next, self);                                             // 93  // 101
          }),                                                                                           // 94  // 102
          removeElement: makeHook(this._alluihooks.remove, function(node) {                             // 95  // 103
            return UiHooks.defaults.remove(node);                                                       // 96  // 104
          })                                                                                            // 97  // 105
        };                                                                                              // 98  // 106
                                                                                                        // 99  // 107
      });                                                                                               // 100
    }                                                                                                   // 101
  });                                                                                                   // 102
};                                                                                                      // 103
                                                                                                        // 104
//////////////////////////////////////////////////////////////////////////////////////////////////////////     // 113
                                                                                                               // 114
}).call(this);                                                                                                 // 115
                                                                                                               // 116
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['gwendall:ui-hooks'] = {}, {
  UiHooks: UiHooks
});

})();
