//////////////////////////////////////////////////////////////////////////
//                                                                      //
// This is a generated file. You can view the original                  //
// source in your browser if your browser supports source maps.         //
// Source maps are supported by all recent versions of Chrome, Safari,  //
// and Firefox, and by Internet Explorer 11.                            //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var _ = Package.underscore._;
var Mongo = Package.mongo.Mongo;

/* Package-scope variables */
var ReactiveAggregate;

(function(){

//////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                          //
// packages/jcbernack_reactive-aggregate/aggregate.js                                       //
//                                                                                          //
//////////////////////////////////////////////////////////////////////////////////////////////
                                                                                            //
ReactiveAggregate = function (sub, collection, pipeline, options) {                         // 1
  var defaultOptions = {                                                                    // 2
    observeSelector: {},                                                                    // 3
    observeOptions: {},                                                                     // 4
    clientCollection: collection._name                                                      // 5
  };                                                                                        // 6
  options = _.extend(defaultOptions, options);                                              // 7
                                                                                            // 8
  var initializing = true;                                                                  // 9
  sub._ids = {};                                                                            // 10
  sub._iteration = 1;                                                                       // 11
                                                                                            // 12
  function update() {                                                                       // 13
    if (initializing) return;                                                               // 14
    // add and update documents on the client                                               // 15
    collection.aggregate(pipeline).forEach(function (doc) {                                 // 16
      if (!sub._ids[doc._id]) {                                                             // 17
        sub.added(options.clientCollection, doc._id, doc);                                  // 18
      } else {                                                                              // 19
        sub.changed(options.clientCollection, doc._id, doc);                                // 20
      }                                                                                     // 21
      sub._ids[doc._id] = sub._iteration;                                                   // 22
    });                                                                                     // 23
    // remove documents not in the result anymore                                           // 24
    _.forEach(sub._ids, function (v, k) {                                                   // 25
      if (v != sub._iteration) {                                                            // 26
        delete sub._ids[k];                                                                 // 27
        sub.removed(options.clientCollection, k);                                           // 28
      }                                                                                     // 29
    });                                                                                     // 30
    sub._iteration++;                                                                       // 31
  }                                                                                         // 32
                                                                                            // 33
  // track any changes on the collection used for the aggregation                           // 34
  var query = collection.find(options.observeSelector, options.observeOptions);             // 35
  var handle = query.observeChanges({                                                       // 36
    added: update,                                                                          // 37
    changed: update,                                                                        // 38
    removed: update,                                                                        // 39
    error: function (err) {                                                                 // 40
      throw err;                                                                            // 41
    }                                                                                       // 42
  });                                                                                       // 43
  // observeChanges() will immediately fire an "added" event for each document in the query
  // these are skipped using the initializing flag                                          // 45
  initializing = false;                                                                     // 46
  // send an initial result set to the client                                               // 47
  update();                                                                                 // 48
  // mark the subscription as ready                                                         // 49
  sub.ready();                                                                              // 50
                                                                                            // 51
  // stop observing the cursor when the client unsubscribes                                 // 52
  sub.onStop(function () {                                                                  // 53
    handle.stop();                                                                          // 54
  });                                                                                       // 55
};                                                                                          // 56
                                                                                            // 57
//////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['jcbernack:reactive-aggregate'] = {}, {
  ReactiveAggregate: ReactiveAggregate
});

})();
