//////////////////////////////////////////////////////////////////////////
//                                                                      //
// This is a generated file. You can view the original                  //
// source in your browser if your browser supports source maps.         //
// Source maps are supported by all recent versions of Chrome, Safari,  //
// and Firefox, and by Internet Explorer 11.                            //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var Mongo = Package.mongo.Mongo;
var _ = Package.underscore._;
var Tracker = Package.tracker.Tracker;
var Deps = Package.tracker.Deps;
var EJSON = Package.ejson.EJSON;
var assert = Package['peerlibrary:assert'].assert;
var DataLookup = Package['peerlibrary:data-lookup'].DataLookup;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;
var check = Package.check.check;
var Match = Package.check.Match;
var Symbol = Package['ecmascript-runtime-client'].Symbol;
var Map = Package['ecmascript-runtime-client'].Map;
var Set = Package['ecmascript-runtime-client'].Set;

/* Package-scope variables */
var __coffeescriptShare;

(function(){

///////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                   //
// packages/peerlibrary_subscription-data/lib.coffee.js                                              //
//                                                                                                   //
///////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                     //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var SUBSCRIPTION_ID_REGEX, checkPath, checkSubscriptionDataId, subscriptionDataSet;                  // 1
                                                                                                     //
checkPath = function(path) {                                                                         // 1
  var field, update, value;                                                                          // 2
  if (_.isString(path)) {                                                                            //
    check(path, Match.NonEmptyString);                                                               //
    if (path === '_id' || path === '_connectionId') {                                                //
      throw new Match.Error("Cannot modify '" + path + "'.");                                        // 5
    }                                                                                                //
  } else {                                                                                           //
    update = path;                                                                                   //
    check(update, Object);                                                                           //
    for (field in update) {                                                                          // 12
      value = update[field];                                                                         //
      if (field === '_id' || field === '_connectionId') {                                            //
        throw new Match.Error("Cannot modify '" + field + "'.");                                     // 13
      }                                                                                              //
      if (field[0] === '$') {                                                                        //
        throw new Match.Error("Invalid field name '" + field + "'.");                                // 16
      }                                                                                              //
    }                                                                                                // 12
  }                                                                                                  //
  return true;                                                                                       //
};                                                                                                   // 1
                                                                                                     //
checkSubscriptionDataId = function(subscriptionDataId) {                                             // 20
  var splits;                                                                                        // 21
  check(subscriptionDataId, Match.NonEmptyString);                                                   //
  splits = subscriptionDataId.split('_');                                                            //
  if (splits.length !== 2) {                                                                         //
    throw new Match.Error("Invalid subscriptionDataId '" + subscriptionDataId + "'.");               // 25
  }                                                                                                  //
  check(splits[0], Match.DocumentId);                                                                //
  check(splits[1], Match.DocumentId);                                                                //
  return true;                                                                                       //
};                                                                                                   // 20
                                                                                                     //
SUBSCRIPTION_ID_REGEX = /_.+?$/;                                                                     // 32
                                                                                                     //
subscriptionDataSet = function(collection, connectionId, subscriptionDataId, path, value) {          // 34
  var update;                                                                                        // 35
  if (Meteor.isClient) {                                                                             //
    check(connectionId, null);                                                                       //
    check(subscriptionDataId, Match.DocumentId);                                                     //
  } else {                                                                                           //
    check(connectionId, Match.DocumentId);                                                           //
    check(subscriptionDataId, Match.Where(checkSubscriptionDataId));                                 //
  }                                                                                                  //
  check(path, Match.Where(checkPath));                                                               //
  check(value, Match.Any);                                                                           //
  if (_.isString(path)) {                                                                            //
    update = {};                                                                                     //
    if (value === void 0) {                                                                          //
      update.$unset = {};                                                                            //
      update.$unset[path] = '';                                                                      //
    } else {                                                                                         //
      update.$set = {};                                                                              //
      update.$set[path] = value;                                                                     //
    }                                                                                                //
  } else {                                                                                           //
    update = _.extend(path, {                                                                        //
      _connectionId: connectionId                                                                    //
    });                                                                                              //
  }                                                                                                  //
  return collection.update({                                                                         //
    _id: subscriptionDataId,                                                                         //
    _connectionId: connectionId                                                                      //
  }, update);                                                                                        //
};                                                                                                   // 34
                                                                                                     //
share.handleMethods = function(connection, collection, subscriptionDataId) {                         // 70
  var dataFunction, setDataFunction;                                                                 // 71
  dataFunction = function(path, equalsFunc) {                                                        //
    var fields, getData;                                                                             // 72
    getData = function(fields) {                                                                     //
      var data;                                                                                      // 73
      data = collection.findOne(subscriptionDataId, {                                                //
        fields: fields                                                                               //
      });                                                                                            //
      if (!data) {                                                                                   //
        return data;                                                                                 // 76
      }                                                                                              //
      return _.omit(data, '_id', '_connectionId');                                                   //
    };                                                                                               //
    if (path != null) {                                                                              //
      if (_.isString(path)) {                                                                        //
        fields = {};                                                                                 //
        fields[path] = 1;                                                                            //
      } else {                                                                                       //
        fields = {                                                                                   //
          _connectionId: 0                                                                           //
        };                                                                                           //
      }                                                                                              //
      return DataLookup.get(function() {                                                             //
        return getData(fields);                                                                      //
      }, path, equalsFunc);                                                                          //
    } else {                                                                                         //
      return getData({                                                                               //
        _connectionId: 0                                                                             //
      });                                                                                            //
    }                                                                                                //
  };                                                                                                 //
  setDataFunction = function(path, value) {                                                          //
    var args, connectionId, oldValue;                                                                // 102
    oldValue = Tracker.nonreactive((function(_this) {                                                //
      return function() {                                                                            //
        return dataFunction(path);                                                                   //
      };                                                                                             //
    })(this));                                                                                       //
    if (EJSON.equals(value, oldValue)) {                                                             //
      return;                                                                                        // 105
    }                                                                                                //
    if (Meteor.isClient) {                                                                           //
      if (value === void 0) {                                                                        //
        args = [subscriptionDataId, path];                                                           //
      } else {                                                                                       //
        args = [subscriptionDataId, path, value];                                                    //
      }                                                                                              //
      return connection.apply('_subscriptionDataSet', args, (function(_this) {                       //
        return function(error) {                                                                     //
          if (error) {                                                                               //
            return console.error("_subscriptionDataSet error", error);                               //
          }                                                                                          //
        };                                                                                           //
      })(this));                                                                                     //
    } else {                                                                                         //
      connectionId = subscriptionDataId.replace(SUBSCRIPTION_ID_REGEX, '');                          //
      return subscriptionDataSet(collection, connectionId, subscriptionDataId, path, value);         //
    }                                                                                                //
  };                                                                                                 //
  return {                                                                                           //
    data: dataFunction,                                                                              //
    setData: setDataFunction                                                                         //
  };                                                                                                 //
};                                                                                                   // 70
                                                                                                     //
share.subscriptionDataMethods = function(collection) {                                               // 121
  return {                                                                                           //
    _subscriptionDataSet: function(subscriptionDataId, path, value) {                                //
      var connectionId;                                                                              // 123
      check(subscriptionDataId, Match.DocumentId);                                                   //
      check(path, Match.Where(checkPath));                                                           //
      check(value, Match.Any);                                                                       //
      if (Meteor.isClient) {                                                                         //
        connectionId = null;                                                                         //
      } else {                                                                                       //
        connectionId = this.connection.id;                                                           //
        subscriptionDataId = connectionId + "_" + subscriptionDataId;                                //
      }                                                                                              //
      return subscriptionDataSet(collection, connectionId, subscriptionDataId, path, value);         //
    }                                                                                                //
  };                                                                                                 //
};                                                                                                   // 121
                                                                                                     //
///////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

///////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                   //
// packages/peerlibrary_subscription-data/client.coffee.js                                           //
//                                                                                                   //
///////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                     //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var Connection, originalLivedataConnected, originalSubscribe,                                        // 1
  slice = [].slice;                                                                                  //
                                                                                                     //
Connection = Meteor.connection.constructor;                                                          // 1
                                                                                                     //
Connection.prototype._initializeSubscriptionData = function() {                                      // 3
  if (this._subscriptionData) {                                                                      //
    return;                                                                                          // 4
  }                                                                                                  //
  this._subscriptionData = new Mongo.Collection('_subscriptionData', {                               //
    connection: this                                                                                 //
  });                                                                                                //
  return this.methods(share.subscriptionDataMethods(this._subscriptionData));                        //
};                                                                                                   // 3
                                                                                                     //
originalLivedataConnected = Connection.prototype._livedata_connected;                                // 10
                                                                                                     //
Connection.prototype._livedata_connected = function() {                                              // 11
  var args;                                                                                          // 12
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];                                      //
  this._initializeSubscriptionData();                                                                //
  return originalLivedataConnected.apply(this, args);                                                //
};                                                                                                   // 11
                                                                                                     //
originalSubscribe = Connection.prototype.subscribe;                                                  // 16
                                                                                                     //
Connection.prototype.subscribe = function() {                                                        // 17
  var args, handle;                                                                                  // 18
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];                                      //
  this._initializeSubscriptionData();                                                                //
  handle = originalSubscribe.apply(this, args);                                                      //
  return _.extend(handle, share.handleMethods(this, this._subscriptionData, handle.subscriptionId));
};                                                                                                   // 17
                                                                                                     //
Meteor.subscribe = _.bind(Meteor.connection.subscribe, Meteor.connection);                           // 25
                                                                                                     //
///////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['peerlibrary:subscription-data'] = {};

})();
